package com.example.prm02

import android.app.Activity
import android.app.AlertDialog
import android.app.DatePickerDialog
import android.content.ContentValues
import android.content.Intent
import android.graphics.Color
import android.net.Uri
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import android.widget.Toast
import androidx.core.graphics.toColor
import kotlinx.android.synthetic.main.activity_add_debtor.*
import java.text.SimpleDateFormat
import java.util.*

class AddDebtorActivity : AppCompatActivity() {

    private lateinit var dbHelper: DbHelper

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_add_debtor)

        val ifEditable = false

        dbHelper = DbHelper(this)


        bSave.setOnClickListener {
            saveDebtor()
        }

        bCancel.setOnClickListener {
            finish()
        }

        bDelete.setOnClickListener{
            Toast.makeText(applicationContext, "in order to delete save data first", Toast.LENGTH_SHORT).show()
        }

        bSendSms.setOnClickListener{
            Toast.makeText(applicationContext, "in order to send SMS save data first", Toast.LENGTH_SHORT).show()
        }

        bSimulate.setOnClickListener{
            Toast.makeText(applicationContext, "in order to simulate save data first", Toast.LENGTH_SHORT).show()
        }


    }

    private fun saveDebtor() {

        var isValid = true
        val pattern = "[0-9]+((\\.[0-9]+)|())".toRegex()

        etName.error = if (etName?.text.toString().isEmpty()) {
            isValid = false
            "Name is required Field"
        } else null

        etDebt.error = if (etDebt?.text.toString().isEmpty()) {
            isValid = false
            "Debt is required Field"
        } else null

        etDebt.error = if (!pattern.matches(etDebt?.text.toString()) ) {
            isValid = false
            "Not valid debt value"
        } else null

        if (isValid) {
            val name = etName?.text.toString()
            val debt = etDebt?.text.toString()

            val db = dbHelper.writableDatabase

            val values = ContentValues()
            values.put(DbContract.DebtorEntry.COLUMN_NAME, name)
            values.put(DbContract.DebtorEntry.COLUMN_DEBT, debt)

            val result = db.insert(DbContract.DebtorEntry.TABLE_NAME, null, values)

            setResult(Activity.RESULT_OK, Intent())

            Toast.makeText(applicationContext, "Debtor Added", Toast.LENGTH_SHORT).show()
//            var t = Toast.makeText(applicationContext, "Debtor Added", Toast.LENGTH_SHORT)
//                t.view.setBackgroundColor(Color.GREEN)
//                t.show()

        }

        if (!isValid) {
//            Toast.makeText(applicationContext, "Error: Debtor Not Added", Toast.LENGTH_SHORT).show()

            var t = Toast.makeText(applicationContext, "Error: enter debtor data", Toast.LENGTH_SHORT)
                t.view.setBackgroundColor(Color.RED)
                t.show()
        }

        finish()
    }

}
