package com.example.prm02

import android.app.Activity
import android.app.AlertDialog
import android.content.Context
import android.content.Intent
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import androidx.recyclerview.widget.RecyclerView
import kotlinx.android.synthetic.main.activity_main.*
import kotlinx.android.synthetic.main.item_debtor.view.*
import kotlinx.android.synthetic.main.item_debtor.view.*

class DebtorListAdapter(private val context: Context?, refreshable: IRefreshable) : RecyclerView.Adapter<DebtorListAdapter.DebtorViewHolder>() {

    lateinit var debtorsList: ArrayList<Debtor>
    val TAG = DebtorListAdapter::class.java.name
    val refreshable=refreshable

//    val iRefreshable = iRefreshable


    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): DebtorViewHolder {
        val itemView = LayoutInflater.from(context).inflate(R.layout.item_debtor, parent, false)
        return DebtorViewHolder(itemView)
    }

    override fun getItemCount(): Int  = debtorsList.size

    override fun onBindViewHolder(holder: DebtorViewHolder, position: Int) {
        val debtor = debtorsList[position]
        holder.setData(debtor.name, debtor.debt, position)
        holder.setListener()
    }

    fun setDebtors(debtors: ArrayList<Debtor>) {
        debtorsList = debtors
        notifyDataSetChanged()
    }

    inner class DebtorViewHolder(itemView: View)  : RecyclerView.ViewHolder(itemView) {
        var pos = 0

        fun setData(name: String, debt: String, pos: Int) {
            itemView.tvName.text = name
            itemView.tvDebt.text = debt
            this.pos = pos
        }

        fun setListener() {
            itemView.setOnClickListener{
//                val dbHelper = DbHelper(context)
//                var debtor = DataManager.fetchDebtor(dbHelper, debtorsList[pos].id.toString() )
//
//                Log.i(TAG, debtor.toString())

                val intent = Intent(context, UpdateDebtorActivity::class.java)
                intent.putExtra(DbContract.DebtorEntry.COLUMN_ID, debtorsList[pos].id )
                (context as Activity).startActivityForResult(intent, 2)
            }
            itemView.setOnLongClickListener{
                val builder = AlertDialog.Builder(context)
                val dbHelper = DbHelper(context)

                builder.setMessage("Do you want to delete debt ?")
                    .setPositiveButton("yes") { dialog, eId ->
                        val result = DataManager.deleteDebtor(dbHelper, debtorsList[pos].id )
                        notifyDataSetChanged()
                        setDebtors(DataManager.fetchAllDebtors(dbHelper))

                        refreshable.refreshDebtTotal()

                        Toast.makeText(
                            context, "$result record deleted",
                            Toast.LENGTH_SHORT
                        ).show()

                    }
                    .setNegativeButton("No") { dialog, id ->
                        dialog.dismiss()
                    }

                val dialog = builder.create()
                dialog.setTitle("Are you sure")
                dialog.show()
//                notifyDataSetChanged()

                true
            }
        }

    }
}
